Class | Sequel::SQL::ComplexExpression
In: | lib/sequel/sql.rb
Parent: | Expression

Represents a complex SQL expression, with a given operator and one or more attributes (which may also be ComplexExpressions, forming a tree). This class is the backbone of the blockless filter support in Sequel.

This is an abstract class that is not that useful by itself. The subclasses BooleanExpression, NumericExpression, and StringExpression define the behavior of the DSL via operators.

### Methods

== eql? new

### Included Modules

AliasMethods CastMethods OrderMethods SubscriptMethods

### Constants

OPERTATOR_INVERSIONS | = | {:AND => :OR, :OR => :AND, :< => :>=, :> => :<=, :<= => :>, :>= => :<, :'=' => :'!=' , :'!=' => :'=', :LIKE => :'NOT LIKE', :'NOT LIKE' => :LIKE, :~ => :'!~', :'!~' => :~, :IN => :'NOT IN', :'NOT IN' => :IN, :IS => :'IS NOT', :'IS NOT' => :IS, :'~*' => :'!~*', :'!~*' => :'~*', :NOT => :NOOP, :NOOP => :NOT, :ILIKE => :'NOT ILIKE', :'NOT ILIKE'=>:ILIKE} |  | A hash of the opposite for each operator symbol, used for inverting objects.
MATHEMATICAL_OPERATORS | = | [:+, :-, :/, :*] |  | Mathematical Operators used in NumericMethods
BITWISE_OPERATORS | = | [:&, :|, :^, :<<, :>>] |  | Mathematical Operators used in NumericMethods
INEQUALITY_OPERATORS | = | [:<, :>, :<=, :>=] |  | Inequality Operators used in InequalityMethods
BOOLEAN_OPERATOR_METHODS | = | {:& => :AND, :| =>:OR} |  | Hash of ruby operator symbols to SQL operators, used in BooleanMethods
IS_OPERATORS | = | [:IS, :'IS NOT'] |  | Operators that use IS, used for special casing to override literal true/false values
TWO_ARITY_OPERATORS | = | [:'=', :'!=', :LIKE, :'NOT LIKE', \ :~, :'!~', :'~*', :'!~*', :IN, :'NOT IN', :ILIKE, :'NOT ILIKE'] + \ INEQUALITY_OPERATORS + BITWISE_OPERATORS + IS_OPERATORS |  | Operator symbols that take exactly two arguments
N_ARITY_OPERATORS | = | [:AND, :OR, :'||'] + MATHEMATICAL_OPERATORS |  | Operator symbols that take one or more arguments
ONE_ARITY_OPERATORS | = | [:NOT, :NOOP, :'B~'] |  | Operator symbols that take one argument

### Attributes

args | [R] | An array of args for this object
op | [R] | The operator symbol for this object

### Public Class methods

new(op, *args)

Set the operator symbol and arguments for this object to the ones given. Convert all args that are hashes or arrays with all two pairs to BooleanExpressions. Raise an error if the operator doesn‘t allow boolean input and a boolean argument is given. Raise an error if the wrong number of arguments for a given operator is used.

[Source]

         # File lib/sequel/sql.rb, line 113
    113:       def initialize(op, *args)
    114:         args.map!{|a| Sequel.condition_specifier?(a) ? SQL::BooleanExpression.from_value_pairs(a) : a}
    115:         case op
    116:         when *N_ARITY_OPERATORS
    117:           raise(Error, "The #{op} operator requires at least 1 argument") unless args.length >= 1
    118:         when *TWO_ARITY_OPERATORS
    119:           raise(Error, "The #{op} operator requires precisely 2 arguments") unless args.length == 2
    120:         when *ONE_ARITY_OPERATORS
    121:           raise(Error, "The #{op} operator requires a single argument") unless args.length == 1
    122:         else
    123:           raise(Error, "Invalid operator #{op}")
    124:         end
    125:         @op = op
    126:         @args = args
    127:       end

### Public Instance methods

==(other)

Alias for eql?

eql?(other)

Returns true if the receiver is the same expression as the the `other` expression.

[Source]

         # File lib/sequel/sql.rb, line 131
    131:       def eql?(other)
    132:         other.is_a?(self.class) && @op.eql?(other.op) && @args.eql?(other.args)
    133:       end

[Validate]